class Building
  attr_accessor :id, :name, :address, :height, :construction_date, :architect, :image_url
  attr_reader 

  def initialize(input_options)
    @id = input_options["id"]
    @name = input_options["name"]
    @address = input_options["address"]
    @height = input_options["height"]
    @construction_date = input_options["construction_date"]
    @architect = input_options["architect"]
    @image_url = input_options["image_url"]
  end

  def self.all
    response = HTTP.get("http://localhost:3000/api/buildings")
    data_hash = response.parse
    data_hash.map { |building| Building.new(building) }
  end

  def self.find(params_id)
    response = HTTP.get("http://localhost:3000/api/buildings/#{params_id}")
    data_hash = response.parse
    Building.new(data_hash)
  end

  def self.create(client_params)
                    
    response = HTTP.post(
                         "http://localhost:3000/api/buildings", 
                         form: client_params
                        )

    data_hash = response.parse
    Building.new(data_hash)
  end

  def update(client_params)
    response = HTTP.patch(
                          "http://localhost:3000/api/buildings/#{self.id}", 
                          form: client_params
                          )
    data_hash = response.parse
    Building.new(data_hash)
  end

  def destroy
    response = HTTP.delete("http://localhost:3000/api/buildings/#{self.id}")
  end

  def architect_array
    self.architect.split(",")
  end

  def self.test
    puts "goodbye world!"
  end

end